Index: /utils/CI/sette/sette_rpt.sh
===================================================================
--- /utils/CI/sette/sette_rpt.sh	(revision 11160)
+++ /utils/CI/sette/sette_rpt.sh	(revision 11161)
@@ -11,99 +11,40 @@
 ##
 
-function restfile() {
-# Rebuild ice restart for SAS CONFIG, and restartability checks. Expects LONG and SHORT run directories.
-# For Stand Alone Surface configuration ocean is not running, just run ice model; so no outputs ocean files.
-# Compares LONG rebuild restart ice file with equivalent entry from the SHORT rebuild restart ice file.
-#
-# check nco module loaded, and load it if not
-if [ ! $( echo $LOADEDMODULES | grep cdo ) ]; then module load cdo >& /dev/null ; fi
+function get_dorv() {
+  if [ $lastchange == 'old' ] ; then 
+    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
+    dorv=`echo $dorv | sed -e 's:.*/::'`
+  else
+    dorv=$lastchange
+  fi
+}
+
+function get_ktdiff() {
+  ktdiff=`diff ${1} ${2} | head -2 | grep it | awk '{ print $4 }'`
+}
+
+function resttest() { 
+#
+# Restartability checks. Expects LONG and SHORT run directories
+# Compares end of LONG stat files with equivalent entries from the SHORT stat files.
 #
   vdir=$1
   nam=$2
   pass=$3
-
-#
-  if [ -d $vdir/$nam ]; then
-    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
-    dorv=`echo $dorv | sed -e 's:.*/::'`
-    rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -2l | head -1 `
-    rep2=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -1l`
-    cd ${SAS_RESTART_DIR}/LONG
-    #SF add here compilation of rebuild_tools to rebuild restart files, and add comparison of restart files
-    cd ${TOOLS_DIR}
-    ./maketools -n REBUILD_NEMO -m ${mach} > /dev/null 2>&1
-    cd ${TOOLS_DIR}/REBUILD_NEMO
-    #SF echo "REBUILD LONG restart SAS files, without standard output"
-    ./rebuild_nemo -t 4 ../../cfgs/ORCA2_SAS_ICE_ST/LONG/SAS_00000240_restart_ice  $NPROC > /dev/null 2>&1
-    #SF echo "REBUILD SHORT restart SAS files, without standard output"
-    ./rebuild_nemo -t 4 ../../cfgs/ORCA2_SAS_ICE_ST/SHORT/SAS_00000240_restart_ice $NPROC >&-
-    cd ${SAS_RESTART_DIR}/LONG
-    #SF echo "COPY rebuild restart files"
-    cp SAS_00000240_restart_ice.nc $vdir/$nam/$mach/$dorv/LONG/.
-    cp ../SHORT/SAS_00000240_restart_ice.nc $vdir/$nam/$mach/$dorv/SHORT/.
-
-    f1o=$vdir/$nam/$mach/$dorv/LONG/SAS_00000240_restart_ice.nc
-    f2o=$vdir/$nam/$mach/$dorv/SHORT/SAS_00000240_restart_ice.nc
-    if  [ ! -f $f1o ] &&  [ ! -f $f2o ] ; then
-      printf "%-27s %s\n" $nam " REBUILD SAS restart ice DOES NOT exists; incomplete test";
-      return;
-    fi
+#
+# get $dorv
+  get_dorv
+#
+# check if directory is here
+  if [ ! -d $vdir/$nam/$mach/$dorv ]; then
+    printf "%-27s %s %s\n" $nam  " directory                  MISSING : " $dorv
+    return
+  fi
+
+  if [ -d $vdir/$nam/$mach/$dorv ]; then
+    # check ocean output
+    runtest $vdir $nam $pass RST
     #
-    done_oce=0
-    #
-  if  [  -f $f1o ] && [  -f $f2o ]; then
-## Compare the two netcdf files
-    cdo diffn $f1o $f2o > cdo_diff.out 2> /dev/null
-## Identical if cdo_diff.out exists but has zero size
-    if [ ! -s cdo_diff.out ]; then
-       difi=0
-    else
-## Identical if first character of $dif ==0
-       dif=$( grep -om1 '[0-9]* of [0-9]* records differ' cdo_diff.out )
-# difi contains the first character of summary of cdo dif. if = 0, then 0 record differ between the 2 files    
-       if [ -n "$dif" ]; then
-           difi=`echo $dif | cut -c -1`
-       fi
-    fi
-    \rm cdo_diff.out 
-
-    if [ $difi == 0 ]; then	
-       if [ $pass == 0 ]; then
-         printf "%-27s %s %s\n" $nam  " ice restarts are IDENTICAL  passed : " $dorv
-       fi
-    else
-       printf "%-27s %s %s\n" $nam  " ice restarts are DIFFERENT  FAILED : " $dorv 
-        #
-	# Offer view of differences on the second pass
-	#
-        if [ $pass == 1 ]; then
-          echo "<return> to view restart_ice.nc differences"
-          read y
-          cdo -diffv $f1o $f2o
-          done_oce=1
-          #echo "<return> to continue"
-          #read y
-        fi
-    fi
-  else
-      printf "%-27s %s\n" $nam " incomplete test";
-      return;
-  fi
-#
-fi
-}
-
-function resttest() { 
-#
-# Restartability checks. Expects LONG and SHORT run directories
-# Compares end of LONG stat files with equivalent entries from the SHORT stat files.
-#
-  vdir=$1
-  nam=$2
-  pass=$3
-#
-  if [ -d $vdir/$nam ]; then
-    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
-    dorv=`echo $dorv | sed -e 's:.*/::'`
+    # run restartibility test
     f1o=$vdir/$nam/$mach/$dorv/LONG/ocean.output
     f1s=$vdir/$nam/$mach/$dorv/LONG/run.stat
@@ -133,5 +74,6 @@
         fi
       else
-        printf "%-27s %s %s\n" $nam  " run.stat    restartability  FAILED : " $dorv 
+        get_ktdiff f1.tmp$$ $f2s
+        printf "\e[38;5;196m%-27s %s %s %s %-5s %s\e[0m\n" $nam  " run.stat    restartability  FAILED : " $dorv " (results are different after " $ktdiff " time steps)"
 #
 # Offer view of differences on the second pass
@@ -162,5 +104,6 @@
         fi
       else
-        printf "%-27s %s %s\n" $nam  " tracer.stat restartability  FAILED : " $dorv 
+        get_ktdiff f1.tmp$$ $f2t
+        printf "\e[38;5;196m%-27s %s %s %s %-5s %s\e[0m\n" $nam  " tracer.stat    restartability  FAILED : " $dorv " (results are different after " $ktdiff " time steps)"
 #
 # Offer view of differences on the second pass
@@ -196,7 +139,18 @@
   pass=$3
 #
-  if [ -d $vdir/$nam ]; then
-    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
-    dorv=`echo $dorv | sed -e 's:.*/::'`
+# get $dorv
+  get_dorv
+#
+# check if directory is here
+  if [ ! -d $vdir/$nam/$mach/$dorv ]; then
+    printf "%-27s %s %s\n" $nam  " directory                  MISSING : " $dorv
+    return
+  fi
+#
+  if [ -d $vdir/$nam/$mach/$dorv ]; then
+    # check ocean output
+    runtest $vdir $nam $pass REPRO
+    #
+    # check reproducibility
     rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | grep REPRO | tail -2l | head -1 `
     rep2=`ls -1rt $vdir/$nam/$mach/$dorv/ | grep REPRO | tail -1l`
@@ -226,5 +180,6 @@
         fi
       else
-        printf "%-27s %s %s\n" $nam  " run.stat    reproducibility FAILED : " $dorv 
+        get_ktdiff $f1s $f2s
+        printf "\e[38;5;196m%-27s %s %s %s %-5s %s\e[0m\n" $nam  " run.stat    reproducibility FAILED : " $dorv " (results are different after " $ktdiff " time steps)"
 #
 # Offer view of differences on the second pass
@@ -252,5 +207,6 @@
         fi
       else
-        printf "%-27s %s %s\n" $nam  " tracer.stat reproducibility  FAILED : " $dorv
+        get_ktdiff $f1t $f2t
+        printf "\e[38;5;196m%-27s %s %s %s %-5s %s\e[0m\n" $nam  " tracer.stat    reproducibility FAILED : " $dorv " (results are different after " $ktdiff " time steps)"
 #
 # Offer view of differences on the second pass
@@ -275,4 +231,89 @@
   fi
 }
+function runcmpres(){
+#
+# compare *.stat file with reference file from a previous sette test or previous version
+# store in NEMO_VALID_REF at revision NEMO_REV_REF
+# Compares end of stat files from each
+#
+  vdir=$1
+  nam=$2
+  vdirref=$3
+  dorvref=$4
+  pass=$5
+#
+# get $dorv
+  get_dorv
+#
+# check if reference directory is present
+  if [ ! -d $vdirref/$nam/$mach/$dorvref ]; then
+    printf "%-27s %s\n" $nam " REFERENCE directory at $dorvref is MISSING"
+    return
+  fi
+  if [ ! -d $vdir/$nam/$mach/$dorv ]; then
+    printf "%-27s %s\n" $nam " VALID     directory at $dorv is MISSING"
+    return
+  fi
+
+#
+  if [ -d $vdir/$nam/$mach/$dorv ]; then
+    f1s=$vdir/$nam/$mach/$dorv/LONG/run.stat
+    f1t=$vdir/$nam/$mach/$dorv/LONG/tracer.stat
+    f2s=$vdirref/$nam/$mach/$dorvref/LONG/run.stat
+    f2t=$vdirref/$nam/$mach/$dorvref/LONG/tracer.stat
+    if  [ ! -f $f1s ] && [ ! -f $f1t ] ; then
+      printf "%-20s %s\n" $nam " incomplete test";
+      return;
+    fi
+    if  [ ! -f $f2s ] && [ ! -f $f2t ] ; then
+      printf "%-20s %s\n" $nam " incomplete test";
+      return;
+    fi
+#
+    done_oce=0
+
+    if  [ -f $f1s ] && [ -f $f2s ] ; then
+      cmp -s $f1s $f2s
+      if [ $? == 0 ]; then
+        if [ $pass == 0 ]; then
+          printf "%-20s %s %s\n" $nam  " run.stat    files are identical "
+        fi
+      else
+        printf "%-20s %s %s\n" $nam  " run.stat    files are DIFFERENT "
+#
+# Offer view of differences on the second pass
+#
+        if [ $pass == 1 ]; then
+          echo "<return> to view run.stat differences"
+          read y
+          sdiff $f1s $f2s
+          done_oce=1
+          echo "<return> to continue"
+          read y
+        fi
+      fi
+    fi
+    # Check tracer.stat files (if they exist)
+#
+    if  [ -f $f1t ] && [ -f $f2t ] ; then
+      cmp -s $f1t $f2t
+      if [ $? == 0 ]; then
+        if [ $pass == 0 ]; then          
+          printf "%-20s %s %s\n" $nam  " tracer.stat files are identical "
+        fi
+      else
+        printf "%-20s %s %s\n" $nam  " tracer.stat files are DIFFERENT "
+#
+# Offer view of differences on the second pass
+#
+        if [ $pass == 1 ]; then
+          echo "<return> to view tracer.stat differences"
+          read y
+          sdiff $f1t $f2t
+        fi
+      fi
+    fi
+  fi
+}
 
 function runtest(){
@@ -284,33 +325,38 @@
   nam=$2
   pass=$3
-#
-  if [ -d $vdir/$nam ]; then
-    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
-    dorv=`echo $dorv | sed -e 's:.*/::'`
-    rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | grep LONG | head -1 `
-    if  [  -z $rep1 ] ; then
-      # Not all configurations test restartability (LONG/SHORT); 
-      # check for a reproducibility directory instead (REPRO)
-      rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | grep REPRO | head -1 `
-    fi
-    f1o=$vdir/$nam/$mach/$dorv/$rep1/ocean.output
-    if  [ ! -f $f1o ] ; then
-      printf "%-27s %s %s\n" $nam " ocean.output is MISSING            : " $dorv
-      return;
-    else 
-      nerr=`grep 'E R R O R' $f1o | wc -l`
-      if [[ $nerr > 0 ]]; then
-        printf "%-27s %s %s\n" $nam " run FAILED : " $dorv
-        if [ $pass == 1 ]; then
-          echo "<return> to view end of ocean.output"
-          read y
-          tail -100 $f1o
-          echo ''
-          echo "full ocean.output available here: $f1o"
-        fi
-      fi
-    fi
+  ttype=$4
+  [[ $ttype == 'RST' ]] && ttype="LONG|SHORT"
+#
+# get $dorv
+  get_dorv
+#
+# no print needed if the repository is not here (already catch before)
+#
+  if [ -d $vdir/$nam/$mach/$dorv/ ]; then
+    #
+    # apply check for all ttype directory
+    rep1=$(ls -rt $vdir/$nam/$mach/$dorv/ | grep -E $ttype)
+    for tdir in $rep1 ; do
+       f1o=$vdir/$nam/$mach/$dorv/$tdir/ocean.output
+       if  [ ! -f $f1o ] ; then
+          if [ $pass == 0 ]; then printf "%-27s %s %s\n" $nam " ocean.output               MISSING : " $dorv ; fi
+          return;
+       else 
+          nerr=`grep 'E R R O R' $f1o | wc -l`
+          if [[ $nerr > 0 ]]; then
+             printf "\e[38;5;196m%-27s %s %s %s\e[0m\n" $nam " run                         FAILED : " $dorv " ( E R R O R in ocean.output) " 
+             if [ $pass == 1 ]; then
+                echo "<return> to view end of ocean.output"
+                read y
+                tail -100 $f1o
+                echo ''
+                echo "full ocean.output available here: $f1o"
+             fi
+             return;
+          fi
+       fi
+    done
   else
-    printf "%-27s %s %s\n" $nam  " directory is MISSING               : " $dorv
+    if [ $pass == 0 ]; then printf "%-27s %s %s\n" $nam  " directory                  MISSING : " $dorv ; fi
   fi
 }
@@ -352,5 +398,6 @@
         fi
       else
-        printf "%-5s %s %-5s %s %s %s\n" $rep1 "AGRIF vs" $rep2 "NOAGRIF run.stat    changed  -     FAILED : " $dorv1 $dorv2
+        get_ktdiff $f1s $f2s
+        printf "\e[38;5;196m%-5s %s %-5s %s %s %s %s %-5s %s\e[0m\n" $rep1 "AGRIF vs" $rep2 "NOAGRIF run.stat    changed  -     FAILED : " $dorv1 $dorv2 " (results are different after " $ktdiff " time steps)"
 #
 # Offer view of differences on the second pass
@@ -376,7 +423,13 @@
 #########################################################################################
 #
-  mach=`grep "COMPILER=" ./sette.sh | sed -e 's/COMPILER=//'`
-  NEMO_VALID=`grep "NEMO_VALIDATION_DIR=" ./param.cfg | sed -e 's/NEMO_VALIDATION_DIR=//'`
-  NEMO_VALID=`eval "echo $NEMO_VALID"`
+# LOAD param variable (COMPILER, NEMO_VALIDATION_DIR, SVN_CMD)
+  SETTE_DIR=$(cd $(dirname "$0"); pwd)
+  MAIN_DIR=$(dirname $SETTE_DIR)
+  . ./param.cfg
+
+  mach=${COMPILER}
+  NEMO_VALID=${NEMO_VALIDATION_DIR}
+  NEMO_VALID_REF=${NEMO_VALIDATION_REF}
+  LANG=en_US
 #
   if [ ! -d $NEMO_VALID ]; then
@@ -386,6 +439,4 @@
 #
 # Directory to run the tests
-  SETTE_DIR=$(cd $(dirname "$0"); pwd)
-  MAIN_DIR=${SETTE_DIR}/..
   CONFIG_DIR0=${MAIN_DIR}/cfgs
   TOOLS_DIR=${MAIN_DIR}/tools
@@ -395,12 +446,22 @@
 # Show current revision tag and branch name
 #
-cmd="svn"
-[ ! -d "$MAIN_DIR/.svn" ] && cmd="git $cmd"
-echo $cmd 
-echo "$MAIN_DIR/.svn"
-lastchange=`$cmd info ${MAIN_DIR} | grep -i "Last Changed Rev:" | sed -e "s/ //g" | cut -d ":" -f 2`
-revision=`$cmd info | grep Revision | cut -d ":" -f 2 | tr -d ' '`
-branchname=`$cmd info | grep URL | rev | cut -d "/" -f 3 | rev`
-echo "SETTE validation report : $branchname @ r$revision  ( last change @ r$lastchange )"
+echo ""
+lastchange=`LC_MESSAGES=${LANG} ${SVN_CMD} info ${MAIN_DIR} | grep 'Last Changed Rev' | awk '{print $NF}'`
+revision=`LC_MESSAGES=${LANG} ${SVN_CMD} info ${MAIN_DIR} | grep 'Revision' | awk '{print $NF}'`
+branchname=`LC_MESSAGES=${LANG} ${SVN_CMD} info ${MAIN_DIR} | grep ^URL | awk -F ipsl/forge/projets/nemo/svn/ '{print $NF}'`
+echo "Current code is : $branchname @ r$revision  ( last change @ r$lastchange )"
+[ `${SVN_CMD} status -q ${MAIN_DIR}/{cfg,tests,src} | wc -l` -ge 1 ] && lastchange=${lastchange}+
+
+# overwrite revision is argument 1 present
+[[ $# -eq 1 ]] && lastchange=$1
+
+echo ""
+echo "SETTE validation report generated for : "
+echo ""
+echo "       $branchname @ r$lastchange (last changed revision)"
+echo ""
+echo "       on $COMPILER arch file"
+echo ""
+
 #
 # The script also needs the date or revision tag. Currently this is taken from the latest sub-directory found in each directory
@@ -419,11 +480,4 @@
 #
 
-# Rebuild and restartability test for SAS
-# clem: not needed anymore
-# for restart_file in WORCA2_SAS_ICE_ST
-# do
-#   restfile $NEMO_VALID $restart_file $pass
-# done
-#
 # Restartability test
  echo ""
@@ -432,5 +486,4 @@
  do
    resttest $NEMO_VALID $restart_test $pass
-   runtest $NEMO_VALID $restart_test $pass
  done
 #
@@ -441,5 +494,4 @@
  do
    reprotest $NEMO_VALID $repro_test $pass
-   runtest $NEMO_VALID $repro_test $pass
  done
 
@@ -450,7 +502,32 @@
  dir2=WAGRIF_DEMO_ST
  identictest $NEMO_VALID $dir1 $dir2 $pass 
-
+#
+# before/after tests
+ if [ $lastchange == 'old' ] ; then
+    echo ""
+    echo "   !---- 'old' specified as revision => no comparison with reference results ----!   "
+    echo ""
+ else
+   echo ""
+   echo "   !----result comparison check----!   "
+   if [ $NEMO_VALID_REF != "/path/to/reference/sette/results" ]; then
+     echo ''
+     echo 'check result differences between :'
+     echo "VALID directory : $NEMO_VALID at rev $lastchange"
+     echo 'and'
+     echo "REFERENCE directory : $NEMO_VALID_REF at rev $NEMO_REV_REF"
+     echo ''
+     for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WISOMIP_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WVORTEX_ST WICE_AGRIF_ST
+     do
+       runcmpres $NEMO_VALID $repro_test $NEMO_VALID_REF $NEMO_REV_REF $pass
+     done
+   else
+     echo ''
+     echo ' No path for comparison specified. Result are not compare with any other revision. '
+     echo ' To do it please fill NEMO_VALID_REF and NEMO_REV_REF in param.cfg. '
+     echo ''
+   fi
+ fi
 done
 #
-
 exit
Index: /utils/CI/sette/sette_test-cases.sh
===================================================================
--- /utils/CI/sette/sette_test-cases.sh	(revision 11160)
+++ /utils/CI/sette/sette_test-cases.sh	(revision 11161)
@@ -12,5 +12,4 @@
 # Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
 # ----------------------------------------------------------------------
-#
 #
 #############################################################
@@ -69,4 +68,9 @@
 #                       in sette_test-cases.sh. (each test in executed in its own directory)
 #
+#  set_valid_dir       : rename ocean.output/run.stat and tracer.stat to avoid checking them in the report 
+#
+#  clean_valid_dir    : rename ocean.output/run.stat and tracer.stat to avoid checking them in the report 
+#                       ( not doing it could lead to false positive )
+#
 #  prepare_job.sh     : to generate the script run_job.sh
 #
@@ -90,12 +94,13 @@
 #########################################################################################
 #
-# Compiler among those in NEMOGCM/ARCH
-COMPILER=X64_ADA
-
-export BATCH_COMMAND_PAR="llsubmit"
-export BATCH_COMMAND_SEQ=$BATCH_COMMAND_PAR
+# LOAD param value
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
+MAIN_DIR=$(dirname $SETTE_DIR)
+. ./param.cfg
+
+export BATCH_COMMAND_PAR=${BATCH_CMD}
+export BATCH_COMMAND_SEQ=${BATCH_CMD}
 export INTERACT_FLAG="no"
 export MPIRUN_FLAG="yes"
-export USING_XIOS="yes"
 #
 export DEL_KEYS="key_iomput"
@@ -105,18 +110,23 @@
 fi
 #
+export ADD_KEYS=""
+if [ ${ADD_NOSIGNEDZERO} == "yes" ]
+ then
+   export ADD_KEYS="key_nosignedzero"
+fi
+#
 # Settings which control the use of stand alone servers (only relevant if using xios)
 #
-export USING_MPMD="no"
 export NUM_XIOSERVERS=4
-export JOB_PREFIX=batch-mpmd
+export JOB_PREFIX=${JOB_PREFIX_MPMD}
 #
 if [ ${USING_MPMD} == "no" ] 
  then
    export NUM_XIOSERVERS=0
-   export JOB_PREFIX=batch
+   export JOB_PREFIX=${JOB_PREFIX_NOMPMD}
 fi
 #
 #
-if [ ${USING_MPMD} == "yes" ] && [ ${USING_XIOS} == "no"]
+if [ ${USING_MPMD} == "yes" ] && [ ${USING_XIOS} == "no" ]
  then
    echo "Incompatible choices. MPMD mode requires the XIOS server"
@@ -125,6 +135,4 @@
 
 # Directory to run the tests
-SETTE_DIR=$(cd $(dirname "$0"); pwd)
-MAIN_DIR=$(dirname $SETTE_DIR)
 CONFIG_DIR0=${MAIN_DIR}/cfgs
 TOOLS_DIR=${MAIN_DIR}/tools
@@ -135,16 +143,16 @@
 cp BATCH_TEMPLATE/${JOB_PREFIX}-${COMPILER} job_batch_template || exit
 # Description of configuration tested:
-# OVERFLOW       : 1  TEST s-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs 
-#                                        & (dynamics) advection schemes: flux form (ubs, centered), vector form (een)
-#                          zps-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs
-#                                        & (dynamics) advection schemes: flux form (ubs, centered), vector form (een, and een + Hollingsworth correction)
-# LOCK_EXCHANGE  : 2
-# VORTEX         : 3
-# ICE_AGRIF      : 4
-# ISOMIP         : 5
+# OVERFLOW       : TEST s-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs 
+#                                     & (dynamics) advection schemes: flux form (ubs, centered), vector form (een)
+#                       zps-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs
+#                                     & (dynamics) advection schemes: flux form (ubs, centered), vector form (een, and een + Hollingsworth correction)
+# LOCK_EXCHANGE  : 
+# VORTEX         : 
+# ICE_AGRIF      : 
+# ISOMIP         : 
 # WAD
 
 
-for config in 1 2 3 4 5 
+for config in ${TEST_CONFIGS}
 do
 
@@ -152,13 +160,15 @@
 #  OVERFLOW
 # ---------
-if [ ${config} -eq 1 ] ;  then
+if [ ${config} == "OVERFLOW" ] ;  then
     ## Restartability tests for OVERFLOW
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=1
@@ -178,9 +188,11 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
 
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"OVF_SHORT\"
@@ -202,5 +214,5 @@
 
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -221,4 +233,6 @@
         . ./all_functions.sh
         . ./prepare_exe_dir.sh
+        set_valid_dir
+        clean_valid_dir
         JOB_FILE=${EXE_DIR}/run_job.sh
         NPROC=1
@@ -233,5 +247,5 @@
         fi
         cd ${SETTE_DIR}
-        . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+        . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
         cd ${SETTE_DIR}
         . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -243,13 +257,15 @@
 #  LOCK_EXCHANGE
 # --------------
-if [ ${config} -eq 2 ] ;  then
+if [ ${config} == "LOCK_EXCHANGE" ] ;  then
     ## Restartability tests for LOCK_EXCHANGE
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=1
@@ -269,9 +285,11 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
 
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"LOCK_SHORT\"
@@ -293,5 +311,5 @@
 
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -312,4 +330,6 @@
         . ./all_functions.sh
         . ./prepare_exe_dir.sh
+        set_valid_dir
+        clean_valid_dir
         JOB_FILE=${EXE_DIR}/run_job.sh
         NPROC=1
@@ -324,5 +344,5 @@
         fi
         cd ${SETTE_DIR}
-        . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+        . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
         cd ${SETTE_DIR}
         . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -335,13 +355,15 @@
 # VORTEX
 # ---------
-if [ ${config} -eq 3 ] ;  then 
+if [ ${config} == "VORTEX" ] ;  then 
 ## Restartability tests for VORTEX
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -370,9 +392,11 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"VORTEX_SHORT\"
@@ -415,5 +439,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -426,4 +450,6 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -456,5 +482,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -463,4 +489,6 @@
     export TEST_NAME="REPRO_3_2"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -494,5 +522,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -504,13 +532,15 @@
 # ICE_AGRIF
 # ---------
-if [ ${config} -eq 4 ] ;  then 
+if [ ${config} == "ICE_AGRIF" ] ;  then 
 ## Restartability tests for ICE_AGRIF
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -539,9 +569,11 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"ICE_AGRIF_SHORT\"
@@ -592,5 +624,5 @@
 
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -604,4 +636,6 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -634,5 +668,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -641,4 +675,6 @@
     export TEST_NAME="REPRO_3_2"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -672,5 +708,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ICE_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -681,13 +717,15 @@
 # ISOMIP
 # ------
-if [ ${config} -eq 5 ] ;  then
+if [ ${config} == "ISOMIP" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=15
@@ -709,9 +747,11 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
 
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"ISOMIP_SHORT\"
@@ -739,5 +779,5 @@
 
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -750,4 +790,6 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=21
@@ -768,5 +810,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -775,4 +817,6 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -793,5 +837,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
+    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
